
function getPointer(e) {
	if (is_ie) {
		DocX = event.clientX + document.body.scrollLeft;
		DocY = event.clientY + document.body.scrollTop;
	} else {
		DocX = e.pageX;
		DocY = e.pageY;
	}
}
document.onmousemove = getPointer;


function draw_menu(id,elements){
	var menu = document.getElementById('menu_newFile'+id);
	if (menu == null){
		menu = document.createElement('DIV');
		menu.id = "menu_newFile"+id;
		menu.style.left = DocX;
		menu.style.top = DocY;
		//menu.style.left = left_pos+"px";
		//menu.style.top = top_pos+"px";
		for(j in elements)
		{
			if (typeof(elements[j]['img']) != 'undefined'){
				var img = document.createElement( 'IMG' );
				img.src = elements[j]['img'];
				menu.appendChild(img);
			}
			var link = document.createElement( 'A' );
			link.href = elements[j]['url'];
			link.appendChild( document.createTextNode( elements[j]['text'] ) );
			menu.appendChild(link);
			menu.appendChild(document.createElement( 'BR' ));
		}

		menu.onmouseout = function () { menuTimeout = setTimeout("document.getElementById('menu_newFile"+id+"').style.visibility = 'hidden'",50);}
		menu.onmouseover = function () { clearTimeout(menuTimeout); };
		menu.className = 'menubox';
		menu.style.zIndex='1';
		document.getElementById('divAppboxHeader').appendChild(menu);
	}
	menu.style.visibility = 'visible';
}

function resizeDiv(){
	defaultHeight = document.body.clientHeight ? document.body.clientHeight : document.body.offsetHeight;
	document.getElementById('fmFileWindow').style.height = defaultHeight-170;
	document.getElementById('content_folders').style.height = defaultHeight - (is_ie ? 230 : 215);

}
var headerMsgLock = false;
var labelBefore = "";
function write_msg (message){
	if (headerMsgLock){
		setTimeout('write_msg("'+message+'");', 300);
		return;
	}
	headerMsgLock = true;
	headerDiv = document.getElementById("divAppboxHeader");
	labelBefore = headerDiv.innerHTML;
	headerDiv.innerHTML = '<table width=100% cellspacing="0" cellpadding="0" border="0"><tbody><tr><th width="40%"></th><th noWrap class="action_info_th">'+message+'</th><th width="40%"></th></tr></tbody></table>';
	setTimeout('headerMsgLock = false; document.getElementById("divAppboxHeader").innerHTML = labelBefore;', 3000);
}

function write_error (message){
	if (headerMsgLock){
		setTimeout('write_error("'+message+'");', 300);
		return;
	}
	headerMsgLock = true;
	headerDiv = document.getElementById("divAppboxHeader");
	labelBefore = headerDiv.innerHTML;
	headerDiv.innerHTML = '<table width=100% cellspacing="0" cellpadding="0" border="0"><tbody><tr><th width="40%"></th><th noWrap class="action_error_th">'+message+'</th><th width="40%"></th></tr></tbody></table>';
	setTimeout('headerMsgLock = false; document.getElementById("divAppboxHeader").innerHTML = labelBefore;', 3000);
}

function displayMessages(){
	var messages = document.getElementById("allMessages");

	for (i=0; i < messages.childNodes.length; i++){
		if (messages.childNodes[i].innerHTML.indexOf(get_lang('Error:')) == 0)
			write_error(messages.childNodes[i].innerHTML);
		else
			write_msg(messages.childNodes[i].innerHTML);
	}
}

function loadPreferences(){
	preferencesEl = document.getElementById('userPreferences');
	preferences = unserialize(preferencesEl.value);
}


function reloadFiles(newCriteria){
	if (newCriteria == criteria)
		order_type = (order_type=='1'?'0':'1')
	else
		criteria = newCriteria;
	toolbar_control('reload');
}
function selectAll(el){
	checkBoxes = document.getElementsByName('fileman');
	if (el.checked)
		for (i=0; i < checkBoxes.length; i++)
			checkBoxes[i].checked = true;
	else
		for (i=0; i < checkBoxes.length; i++)
			checkBoxes[i].checked = false;

}
function borkb(size){
		kbyte = 1024;
		mbyte = kbyte*1024;
		gbyte = mbyte*1024;
		if (!size)
			size = 0;
		if (size < kbyte)
			return size + 'B';
		else if (size < mbyte)
			return parseInt(size/kbyte) + 'KB';
		else if (size < gbyte)
			return (size/mbyte).toFixed(1) + 'MB';
		else
			return parseInt(size/gbyte).toFixed(1) + 'GB';
}

function drawFiles(data){
	var fmFileWindow = document.getElementById('fmFileWindow');
	var files = unserialize(data);
	fmFileWindow.innerHTML = "";
	var newpage;
	var td_hd = '<td style="padding-left: 2px; padding-right: 2px;" valign="middle">';
	var sp_hd = '<span name="head" style="cursor: pointer; cursor: hand;" onclick="reloadFiles(\'';
	var sp_tl = '</span></td>';
	newpage = '<table cellspacing="0" cellpadding="2"><tbody><tr class="message_header">';
	newpage += td_hd+'<input onclick="selectAll(this)" type="checkbox"></td><td></td><td></td>';
	newpage += td_hd+sp_hd+'name\')" id="name">'+get_lang('file name')+sp_tl;
    	if (preferences.mime_type =='1')
		newpage += td_hd+sp_hd+'mime\')" id="mime">'+get_lang('mime type')+sp_tl;
	if (preferences.size =='1')
		newpage += td_hd+sp_hd+'size\')" id="size">'+get_lang('size')+'</a>'+sp_tl;
	if (preferences.created =='1')
		newpage += td_hd+sp_hd+'created\')" id="created">'+get_lang('created')+'</a>'+sp_tl;
	if (preferences.modified =='1')
		newpage += td_hd+sp_hd+'modified\')" id="modified">'+get_lang('modified')+'</a>'+sp_tl;
	if (preferences.owner =='1')
		newpage += td_hd+sp_hd+'owner\')" id="owner">'+get_lang('owner')+'</a>'+sp_tl;
	if (preferences.createdby_id =='1')
		newpage += td_hd+sp_hd+'creatdby\')" id="creatdby">'+get_lang('created by')+'</a>'+sp_tl;
	if (preferences.modifiedby_id =='1')
		newpage += td_hd+sp_hd+'modifdby\')" id="modifdby">'+get_lang('modified by')+'</a>'+sp_tl;
	if (preferences.comment =='1')
		newpage += td_hd+sp_hd+'comm\')" id="comm">'+get_lang('comment')+'</a>'+sp_tl;
	if (preferences.version =='1') newpage += td_hd+sp_hd+'vers\')" id="vers">'+get_lang('version')+'</a>'+sp_tl+'</tr>';
	
	var classTr = "tr_msg_read";
	for (var i=0; i < files.length; i++)
	{
		newpage += '<tr class="'+classTr+'">'+td_hd;
		newpage += '<input name="fileman" value="'+files[i].name+'" type="checkbox"></td>';
		if (permissions['private']) {
			newpage += '<td><img id="restrict_'+files[i].name+'" onclick="setRestricted(\''+files[i].name+'\')" ';
			newpage += 'src="'+templatePath+'images/button_'+(files[i].pub == '1'?'lock':'unlock')+'.png"></td>';
		}
		else
			newpage += '<td></td>';

		if (files[i].mime == 'text/html')
			newpage += '<td><a href="/index.php?menuaction=filemanager.uifilemanager.export&file='+base64_encode(files[i].name)+';path='+base64_encode(currentPath)+'"><img alt="'+get_lang('export')+'" title="'+get_lang('export')+'" src="'+templatePath+'images/button_export.png"></a></td>';
		else
			newpage += '<td></td>';
		newpage += td_hd+'<img src="'+(files[i].icon)+'">';
		newpage += '<a id="name_'+files[i].name+'" href="/index.php?menuaction=filemanager.uifilemanager.view&file='+base64_encode(files[i].name)+'&path='+base64_encode(currentPath)+'" target="_blank">'+files[i].name+'</a>&nbsp;</td>';
		if (preferences.mime_type =='1') newpage += td_hd+files[i].mime+'</td>';
		if (preferences.size =='1') newpage += td_hd+borkb(files[i].size)+'</td>';
		if (preferences.created =='1') newpage += td_hd+files[i].creatd+'</td>';
		if (preferences.modified =='1') newpage += td_hd+files[i].modifd+'</td>';
		if (preferences.owner =='1') newpage += td_hd+files[i].owner+'</td>';
		if (preferences.createdby_id =='1') newpage += td_hd+files[i].creatdby+'</td>';
		if (preferences.modifiedby_id =='1') newpage += td_hd+files[i].modifdby+'</td>';
		if (files[i].comm == null || files[i].comm.length == 0)
			files[i].comm = "&lt;"+get_lang("no comments")+"&gt;";
		if (preferences.comment =='1') newpage += td_hd+'<span id="'+files[i].name+'" onclick="setComments(this)">'+files[i].comm+'</span></td>';
		if (preferences.version =='1') newpage += td_hd+'<span onclick="loadHistory(\''+files[i].name+'\')">'+files[i].vers+'</span></td></tr>';
		// /index.php?menuaction=filemanager.uifilemanager.history&amp;file=MDAxMC5lbWw%253D&amp;path=L2hvbWUvem9yZWlh 
		classTr = (classTr == "tr_msg_read"?"tr_msg_read2":"tr_msg_read");

	}
	fmFileWindow.innerHTML = newpage;
	header = document.getElementsByName('head');
	for (var i=0; i < header.length; i++)
	{
		if (header[i].id == criteria){
			header[i].style.fontWeight = 'bold';
			arrow = document.createElement('IMG');
			if (order_type == '1')
				arrow.src = templatePath+'images/arrow_ascendant.gif';
			else
				arrow.src = templatePath+'images/arrow_descendant.gif';
			header[i].appendChild(arrow);
		}
	}
}


function loadToolbar(){
	if (permissions['read'] == 0)
		return;
	var toolbar = document.getElementById('fmMenu');
	var pageContent = '<table><tbody><tr>';
	var createButton = function(name) { return '<td name="'+name+'" class="toolButton" onclick="toolbar_control(\''+name+'\');" title="'+name+'"><img src="'+templatePath+'images/button_'+name+'.png" alt="'+name+'"><small>'+get_lang(name.replace('_',' '))+'</small></td>'; }

	if (permissions['edit'] != 0){
		pageContent += createButton('edit');
		pageContent += createButton('rename');
	}
	if (permissions['delete'] != 0){
		pageContent += createButton('delete');
		pageContent += createButton('move_to');
	}
	pageContent += createButton('copy_to');

	toolbar.innerHTML = pageContent+'</tr></tbody></table>';


}

function loadPermissions(data){
	var permission = parseInt(data);
	var ACL_READ = 1;
	var ACL_ADD = 2;
	var ACL_EDIT = 4;
	var ACL_DELETE = 8;
	var ACL_PRIVATE = 16;

	permissions['read']=(permission & ACL_READ);
	permissions['add']=(permission & ACL_ADD);
	permissions['edit']=(permission & ACL_EDIT);
	permissions['delete']=(permission & ACL_DELETE);
	permissions['private']=(permission & ACL_PRIVATE);
	loadToolbar();
	loadPreferences();
	toolbar_control('reload');
}

function initDrawApi(){
	currentPath = document.getElementById('currentPath').value;
	cExecute('/index.php?menuaction=filemanager.uifilemanager.get_permissions&path='+base64_encode(currentPath),loadPermissions);
	quotaSize = document.getElementById('quotaSize').value;
	usedSpace = document.getElementById('usedSpace').value;

	document.getElementById('divAppboxHeader').innerHTML = title_app;

	if (parseInt(quotaSize) != 0)
		document.getElementById('content_quota').innerHTML = '<table width="102" cellspacing="0" cellpadding="0" border="0" id="table_quota"><tbody><tr><td width="102" nowrap="true" height="15" background="../phpgwapi/templates/default/images/dsunused.gif"><table cellspacing="0" cellpadding="0" border="0" style="width: '+parseInt((usedSpace/quotaSize)*100)+'%;"><tbody><tr><td height="15" class="dsused"/></tr></tbody></table></td><td nowrap="true" align="center"><span class="boxHeaderText">'+parseInt(usedSpace/quotaSize*100)+'% ('+(usedSpace/1024/1024).toFixed(1)+'M/'+(quotaSize/1024/1024)+'M)</span></td></tr></tbody></table></td></tr></table>';
	displayMessages();
	resizeDiv();
	window.onresize = resizeDiv;
	document.body.style.overflow = "hidden";

	// Disabled for now
	// document.getElementById('main_table').style.visibility = "";

}

